import java.util.*;

public class DemoCollections
{
    public static void arrayDemo() {
        String jan = new String("Jan");
        
        String[] array = new String[4];
        array[0] = jan;
        array[1] = new String("Petr");
        array[2] = jan;
        array[3] = null;
        
        String[] array2 = new String[]{
            new String("Jan"), 
            new String("Petr"), 
            new String("Jan"), 
            null
        };
            
        array[2] = "Karel";
        
        System.out.println(array[3]);

        for (String str: array) {
            System.out.println(str);
        }
        
        for (int i = 0; i < array.length; i++) {
            String str = array[i];
        }
    }
    
    public static void listDemo() {
        String jan = new String("Jan");
        
        List<String> list = new ArrayList<>();
        list.add(jan);
        list.add(new String("Petr"));
        list.add(jan);
        list.add(null);
        
        List<String> list2 = List.of(
            jan, 
            new String("Petr"), 
            jan, 
            null
        );
        
        List<String> list3 =  Arrays.asList(new String[]{
            jan, 
            new String("Petr"), 
            jan, 
            null
        });
        
        List<String> list4 = new ArrayList<>() {{
            add(jan);
            add(new String("Petr"));
            add(jan);
            add(null);
        }};
        
        list.set(3, "Karel");
        
        System.out.println(list.get(3));

        for (String str: list) {
            System.out.println(str);
        }
        
        for (int i = 0; i < list.size(); i++) {
            String str = list.get(i);
        }
    }
    
    public static void setDemo() {
        String jan = new String("Jan");
        
        Set<String> set = new HashSet<>();
        set.add(jan);
        set.add(new String("Petr"));
        set.add(new String("Jan"));
        set.add(null);
        
        Set<String> list2 = Set.of(
            jan, 
            new String("Petr"), 
            jan, 
            null
        );
        
        Set<String> list4 = new HashSet<>() {{
            add(jan);
            add(new String("Petr"));
            add(jan);
            add(null);
        }};
        
        //set.set(3, "Karel");
        
        //System.out.println(list.get(3));

        for (String str: set) {
            System.out.println(str);
        }
        
        //for (int i = 0; i < list.size(); i++) {
        //    String str = list.get(i);
        //}
    }
    
    public static void demo2dList() {
        String[][] array = new String[10][10];
        List<List<String>> list = new ArrayList<>();
        list.add(new ArrayList<>());
        list.add(new ArrayList<>());
        list.add(new ArrayList<>());
        list.add(null);
        // ...
        
        for (int i = 0; i < list.size(); i++) {
            for (int j = 0; j < list.get(i).size(); j++) {
                String str = list.get(i).get(j);
            }
        }
    }
    
    public static void demoMap() {
        Map<String, Integer> map = new HashMap<>();
        map.put("Jan", 30_000);
        map.put("Karel", 60_000);
        map.put("Jan", 40_000);
        map.put("Jana", 40_000);
        
        Set<String> keyset = map.keySet();
        for (String key: map.keySet()) {
            int salary = map.get(key);
        }
        
        Collection<Integer> values = map.values();
        for (Integer salary: map.values()) {
            
        }
        
        
        var entryset = map.entrySet();
        for (Map.Entry<String,Integer> entry: map.entrySet()) {
            String key = entry.getKey();
            int val = entry.getValue();
        }
        
        map.remove("Jan");
    }
}
